#define __ATCUB_O_(x,...)       __ATCUB__O__(x)
#define __ATCUB__O__(x,...)     __ATCUB_##x##_
#define __ATCUB__               0
#define __ATCUB_float_          1
#define __ATCUB_double_         2


#if (__ATCUB_O_(TYPE)==__ATCUB_double_)
#   define __isDOUBLE__         1
#   define __isFLOAT__          0
#endif
#if (__ATCUB_O_(TYPE)==__ATCUB_float_)
#   define __isDOUBLE__         0
#   define __isFLOAT__          1
#endif
#if (__ATCUB_O_(TYPE)==__ATCUB__)
#   define __isDOUBLE__         0
#   define __isFLOAT__          0
#endif

#undef  __ATCUB__
#undef  __ATCUB_double_
#undef  __ATCUB_float_
#undef  __ATCUB__O__
#undef  __ATCUB_O_

double get_wtime(void);
int do_usleep(int usec);
int get_gpu_id(void);
void print_head(char *func_name);

void
ASPEN_init( int );

void
ASPEN_shutdown( void );

int
ASPEN_get_driver_Version( void );

int
ASPEN_get_runtime_Version( void );

void
ASPEN_SGEMV_t(int blk, float alpha, float beta, float *dA, float *dB,
                    float *dC,
                    int LDA,
                    int N1, int N2);
void
ASPEN_SGEMV_n(int blk, float alpha, float beta, float *dA, float *dB,
                    float *dC,
                    int LDA,
                    int N1, int N2);
void
ASPEN_SSYMVu(int blk, int N, float *dA, int LDA, float *dB,
                    float *dC,
                    float alpha, float beta);

void
ASPEN_DGEMV_t(int blk, double alpha, double beta, double *dA, double *dB,
                    double *dC,
                    int LDA,
                    int N1, int N2);
void
ASPEN_DGEMV_n(int blk, double alpha, double beta, double *dA, double *dB,
                    double *dC,
                    int LDA,
                    int N1, int N2);
void
ASPEN_DSYMVu(int blk, int N, double *dA, int LDA, double *dB,
                    double *dC,
                    double alpha, double beta);


enum S_FUNCS { SGEMV_N, SGEMV_T, SSYMV_U };
enum D_FUNCS { DGEMV_N, DGEMV_T, DSYMV_U };

