#include "../tuning/CURRENT_GPU"

#include "double.h"
#include "aspen_devel.h"


extern "C" void
API(DGEMV_n) ( int blk,
		const scalar_t alpha, const scalar_t beta,
		const scalar_t * a, const scalar_t * x,
		scalar_t * y,
                const int lda,
		const int n1, const int n2 )
{

   if ( n1 <= 0 || n2 <= 0 ) return;
   if ( alpha == CONST(0) && beta == CONST(1) ) return;

   int Ver = API(get_device_CC) ( );

   if ( CURRENT_GPU == Ver ) {
	ASPEN_tuned_kernel_name(DGEMV_n) ( blk,
		alpha, beta, a, x, y, lda, n1, n2 );
   } else {
	; /* unmatched */
   }

}

