#include "float.h"
#include "aspen_devel.h"

extern "C" void
API(SSYMVu) ( const int blk,
	const int n, const scalar_t * A, const int lda,
	const scalar_t * x, scalar_t * y,
	const scalar_t alpha, const scalar_t beta )
{
	API(SSYMVu_LARGE) ( blk, n, A, lda, x, y, alpha, beta );
}

extern "C" void
API(ssymv) ( char uplo, int n,
		scalar_t alpha,
		scalar_t * a, int lda,
		scalar_t * x, int incx,
		scalar_t beta,
		scalar_t * y, int incy )
{
   if ( n <= 0 ) return;
   if ( alpha == CONST(0) && beta == CONST(1) ) return;
   int     upper = (uplo=='U')||(uplo=='u');
   if ( upper && incx == 1 && incy == 1 ) {
      API(SSYMVu_LARGE) ( -1, n, a, lda, x, y, alpha, beta );
   } else {
      cublasSsymv ( uplo, n, alpha, a, lda, x, incx, beta, y, incy );
   }
}

