#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
2014年 10月 27日 月曜日 06:49:46 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-980
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-980";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_5	1
#define	KERNEL_18	1
#define	KERNEL_6	1
#define	KERNEL_7	1
#define	KERNEL_8	1
#define	KERNEL_12	1
#define	KERNEL_13	1
#define	KERNEL_14	1
#define	KERNEL_2	1

if ( n >= 1 && n < 528 ) {
	BLK = 13;
} else
if ( n >= 528 && n < 1082 ) {
	BLK = 8;
} else
if ( n >= 1082 && n < 1594 ) {
	BLK = 2;
} else
if ( n >= 1594 && n < 1728 ) {
	BLK = 13;
} else
if ( n >= 1728 && n < 1938 ) {
	BLK = 2;
} else
if ( n >= 1938 && n < 2016 ) {
	BLK = 5;
} else
if ( n >= 2016 && n < 2138 ) {
	BLK = 2;
} else
if ( n >= 2138 && n < 2304 ) {
	BLK = 5;
} else
if ( n >= 2304 && n < 2560 ) {
	BLK = 12;
} else
if ( n >= 2560 && n < 2592 ) {
	BLK = 5;
} else
if ( n >= 2592 && n < 2663 ) {
	BLK = 7;
} else
if ( n >= 2663 && n < 2688 ) {
	BLK = 5;
} else
if ( n >= 2688 && n < 2747 ) {
	BLK = 6;
} else
if ( n >= 2747 && n < 2880 ) {
	BLK = 5;
} else
if ( n >= 2880 && n < 2988 ) {
	BLK = 6;
} else
if ( n >= 2988 && n < 3011 ) {
	BLK = 14;
} else
if ( n >= 3011 && n < 3072 ) {
	BLK = 5;
} else
if ( n >= 3072 && n < 3105 ) {
	BLK = 6;
} else
if ( n >= 3105 && n < 3168 ) {
	BLK = 5;
} else
if ( n >= 3168 && n < 3264 ) {
	BLK = 14;
} else
if ( n >= 3264 && n < 3341 ) {
	BLK = 6;
} else
if ( n >= 3341 && n < 3364 ) {
	BLK = 14;
} else
if ( n >= 3364 && n < 3456 ) {
	BLK = 5;
} else
if ( n >= 3456 && n < 3495 ) {
	BLK = 6;
} else
if ( n >= 3495 && n < 3840 ) {
	BLK = 18;
} else
if ( n >= 3840 && n < 3869 ) {
	BLK = 6;
} else
if ( n >= 3869 && n < 14000 ) {
	BLK = 14;
} else
if ( n >= 14000 && n < 100000000 ) {
	BLK = 14;
}

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 384 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 256 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 32 , 4 , 3, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 352 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 384 , 1 , 1, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 192 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 288 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 224 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 32 , 3 , 3, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 160 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 160 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 96 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 64 , 4 , 8, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 64 , 3 , 6, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 320 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 352 , 1 , 1, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 256 , 1 , 1, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 288 , 1 , 1, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 32 , 3 , 5, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 320 , 1 , 1, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

