#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
Mon Oct 27 12:13:32 JST 2014
Host on newton.aics27.riken.jp
Device is GeForce-GTX-TITAN-Black
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="newton.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-TITAN-Black";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(15)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_18	1
#define	KERNEL_19	1
#define	KERNEL_7	1
#define	KERNEL_8	1
#define	KERNEL_9	1
#define	KERNEL_10	1
#define	KERNEL_11	1
#define	KERNEL_12	1
#define	KERNEL_14	1
#define	KERNEL_2	1
#define	KERNEL_3	1

if ( n >= 1 && n < 100 ) {
	BLK = 7;
} else
if ( n >= 100 && n < 336 ) {
	BLK = 19;
} else
if ( n >= 336 && n < 457 ) {
	BLK = 3;
} else
if ( n >= 457 && n < 720 ) {
	BLK = 10;
} else
if ( n >= 720 && n < 960 ) {
	BLK = 3;
} else
if ( n >= 960 && n < 1200 ) {
	BLK = 14;
} else
if ( n >= 1200 && n < 1260 ) {
	BLK = 19;
} else
if ( n >= 1260 && n < 1440 ) {
	BLK = 10;
} else
if ( n >= 1440 && n < 1920 ) {
	BLK = 3;
} else
if ( n >= 1920 && n < 1966 ) {
	BLK = 10;
} else
if ( n >= 1966 && n < 2100 ) {
	BLK = 12;
} else
if ( n >= 2100 && n < 2160 ) {
	BLK = 10;
} else
if ( n >= 2160 && n < 2400 ) {
	BLK = 4;
} else
if ( n >= 2400 && n < 2568 ) {
	BLK = 3;
} else
if ( n >= 2568 && n < 2700 ) {
	BLK = 11;
} else
if ( n >= 2700 && n < 2880 ) {
	BLK = 3;
} else
if ( n >= 2880 && n < 3000 ) {
	BLK = 8;
} else
if ( n >= 3000 && n < 3150 ) {
	BLK = 12;
} else
if ( n >= 3150 && n < 3161 ) {
	BLK = 9;
} else
if ( n >= 3161 && n < 3506 ) {
	BLK = 10;
} else
if ( n >= 3506 && n < 3600 ) {
	BLK = 4;
} else
if ( n >= 3600 && n < 3840 ) {
	BLK = 3;
} else
if ( n >= 3840 && n < 4025 ) {
	BLK = 8;
} else
if ( n >= 4025 && n < 4200 ) {
	BLK = 12;
} else
if ( n >= 4200 && n < 4320 ) {
	BLK = 10;
} else
if ( n >= 4320 && n < 4500 ) {
	BLK = 11;
} else
if ( n >= 4500 && n < 4800 ) {
	BLK = 3;
} else
if ( n >= 4800 && n < 5040 ) {
	BLK = 10;
} else
if ( n >= 5040 && n < 5250 ) {
	BLK = 12;
} else
if ( n >= 5250 && n < 5333 ) {
	BLK = 8;
} else
if ( n >= 5333 && n < 5400 ) {
	BLK = 11;
} else
if ( n >= 5400 && n < 5760 ) {
	BLK = 3;
} else
if ( n >= 5760 && n < 5996 ) {
	BLK = 8;
} else
if ( n >= 5996 && n < 6000 ) {
	BLK = 4;
} else
if ( n >= 6000 && n < 6175 ) {
	BLK = 9;
} else
if ( n >= 6175 && n < 6300 ) {
	BLK = 12;
} else
if ( n >= 6300 && n < 6480 ) {
	BLK = 10;
} else
if ( n >= 6480 && n < 6600 ) {
	BLK = 8;
} else
if ( n >= 6600 && n < 6720 ) {
	BLK = 3;
} else
if ( n >= 6720 && n < 6840 ) {
	BLK = 2;
} else
if ( n >= 6840 && n < 6977 ) {
	BLK = 18;
} else
if ( n >= 6977 && n < 7200 ) {
	BLK = 8;
} else
if ( n >= 7200 && n < 7260 ) {
	BLK = 18;
} else
if ( n >= 7260 && n < 7350 ) {
	BLK = 12;
} else
if ( n >= 7350 && n < 7441 ) {
	BLK = 18;
} else
if ( n >= 7441 && n < 7560 ) {
	BLK = 2;
} else
if ( n >= 7560 && n < 7636 ) {
	BLK = 18;
} else
if ( n >= 7636 && n < 7680 ) {
	BLK = 9;
} else
if ( n >= 7680 && n < 7800 ) {
	BLK = 8;
} else
if ( n >= 7800 && n < 7831 ) {
	BLK = 18;
} else
if ( n >= 7831 && n < 7875 ) {
	BLK = 2;
} else
if ( n >= 7875 && n < 14000 ) {
	BLK = 18;
} else
if ( n >= 14000 && n < 100000000 ) {
	BLK = 18;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 256 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 128 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 128 , 1 , 8, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 320 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 384 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 64 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 160 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 128 , 1 , 6, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 128 , 1 , 7, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 96 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 96 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 256 , 1 , 7, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 96 , 1 , 7, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 128 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 288 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 96 , 3 , 4, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

